Index: /trunk/SophyaPI/PI/pidrawer.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pidrawer.cc	(revision 4077)
@@ -52,15 +52,4 @@
 //--
 
-// Valeur par defaut global pour TailleFonteAuto 
-double PIDrawer::glDefAFSzFrac = 0.04;
-void PIDrawer::SetGlDefAutoFontSizeFrac(double fszf)
-{
-  if (fszf>1.e-6)  glDefAFSzFrac = fszf;
-}
-double PIDrawer::GetGlDefAutoFontSizeFrac()
-{
-  return glDefAFSzFrac;
-}
-
 PIDrawer::PIDrawer()
 {
@@ -76,5 +65,5 @@
   limitsFixed = false;
   SetAxesFlags(kAxesNone);   // Pas de trace d'axes par defaut 
-  ConfigureAutoFontSize(true, glDefAFSzFrac);
+  SetAxesAutoFontSize();
 
   mDndfg = false;  // Pour controle de l'appel de Detach() si delete
@@ -118,19 +107,11 @@
 
 //++
-// Titre	Gestion des axes, des limites et coordonnees fenetre
+// Titre	Gestion des axes et des limites
 //      Le tracé des axes 2D est pris en charge par la classe PIAxes.
 //--
 //++
-// double BWdgXPos()  BWdgYPos()
-//	Renvoient les positions (X,Y) du drawer dans l'objet PIBaseWdg. Ces positions ne sont 
-//	valables qu'apres appel a SetDrwWdg() - Ne peut donc etre utilise en pratique que dans 
-//	la methode Draw.
-// double  BWdgXSize()  BWdgYSize()
-//	Renvoient les tailles (X,Y) du drawer dans l'objet PIBaseWdg. Meme remarque que pour 
-//	BWdgXPos()  BWdgYPos(). 
-//
 // void  SetLimits(double xmin, double xmax, double ymin, double ymax, -
 //                 int axrl=kAxeDirSame, int ayud=kAxeDirSame)
-//	Définit les limites du système de coordonnées du Drawer.
+//	Définit les limites du système de coordonnées.
 //|	kAxeDirSame , kAxeDirAuto
 //|	kAxeDirLtoR , kAxeDirRtoL  (Axe X)
@@ -162,20 +143,12 @@
 //|	kMajTicks , kMinTicks , kLabels , kGridOn
 //|	kAxesDflt , kAxesNone
-// void ConfigureAutoFontSize(bool afsz=true, double fszf=0.05)
-//	Si "fg==true", la taille de la fonte par le drawer, est 
+// void SetAxesAutoFontSize(bool fg=true)
+//	Si "fg==true", la taille de la fonte pour les labels d'axes (chiffres) est 
 //	choisie automatiquement, en s'adaptant à la taille de la zone de tracé - 
-//	sinon, taille de la fonte de l'objet PIDrawer. Cette taille est donnée par
-//	FontSize=(YMax()-YMin())*(mFontSzF=fszf). "mFontSzF=fszf" n'est mis à jour
-//	que si fszf>0. Le décodage des attributs graphiques par DecodeOptionString() 
-//	("autofontsize=fszf" et "fixedfontsize")  permet de modifier ces attributs de 
-//	choix automtique de fonte. Utilisé en particulier par PIElDrawer pour 
-//	le tracé les labels d'axes (chiffres).
+//	sinon, taille de la fonte de l'objet PIDrawer.
 // unsigned int GetAxesFlags()
 //	Renvoie les attributs de tracé d'axes  
-// bool  GetAutoFontSizeState() 
-//	Renvoie la valeur du flag de choix automatique de taille de fonte.
-// double  GetAutoFontSizeFraction()
-//	Renvoie la valeur de la fraction de taille ("mFontSzF) pour lee 
-//	choix automatique de taille de fonte.
+// bool  isAxesAutoFontSize()
+//	Renvoie la valeur du flag de choix automatique de taille de fonte pour axes.
 // void  DrawAxes(PIGraphicUC* g)
 //	Méthode de tracé des axes (le tracé est pris en charge par la classe *PIAxes*)
@@ -210,7 +183,9 @@
   if (ayud == kAxeDirDownUp)  aYdir = false;
   else if (ayud == kAxeDirUpDown)  aYdir = true;
-  //cerr<<" DBG-SetLimits xmax-xmin= "<<xmax-xmin<<" xmin,max="<<xmin<<","<<xmax<<endl;
+  //  cerr << " DBG-SetLimits xmax-xmin= " << xmax-xmin << " xmin,max=" 
+  //     << xmin << "," << xmax << endl;
   UC_CheckMinMaxDiff(xmin, xmax);
-  //cerr<<" DBG-SetLimits ymax-ymin= "<<ymax-ymin<<" ymin,max="<<ymin<<","<<ymax<<endl;
+  //cerr << " DBG-SetLimits ymax-ymin= " << ymax-ymin << " ymin,max=" 
+  //     << ymin << "," << ymax << endl;
   UC_CheckMinMaxDiff(ymin, ymax);
   xMin = xmin;
@@ -420,30 +395,9 @@
 PIDrawer::DecodeOptionString(vector<string> & opt, bool rmdecop)
 {
-  int nopt0 = opt.size();
-  if (nopt0 < 1)  return(0);  
+  if (opt.size() < 1)  return(0);  
   PIGraphicAtt gratt;
-  int ndec1 = gratt.DecodeAttStrings(opt, rmdecop);
+  int ndec = gratt.DecodeAttStrings(opt, rmdecop);
   UpdateGraphicAtt(gratt);
-  if ((nopt0 - ndec1) < 1) return(ndec1);  // si tout a ete decode
-  vector<string> udopt;
-  unsigned int k = 0;
-  int ndec = opt.size();
-  string opts;
-  for( k=0; k<opt.size(); k++ ) {
-    opts = opt[k];
-    if (opts.substr(0,13) == "autofontsize=") {
-       double fszf = atof(opts.substr(13).c_str());
-       ConfigureAutoFontSize(true, fszf);
-    }
-    else if (opts == "fixedfontsize")
-       ConfigureAutoFontSize(false, -1.);  
-    else {
-      ndec--;
-      if (rmdecop)  udopt.push_back(opts);
-    }
-  }
-
-  if (rmdecop)  opt = udopt;
-  return(ndec+ndec1); 
+  return(ndec);
 }
 
@@ -470,7 +424,4 @@
   info += "   FontAtt: roman, bold, italic, bolditalic  \n";
   info += "   FontSize: 6,8,10,12... (pts) - integer \n";
-  info += ">>> Automatic font size selection : \n";
-  info += "    autofontsize=FontSizeFrac fixedfontsize \n";
-  info += ">>> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32 \n";
   info += ">>> marker=MarkerType,MarkerSize (MarkerSize: integer 3,5,7... \n";
   info += "   MarkerType: dot, plus, cross, circle, fcircle, box, fbox \n";
@@ -554,5 +505,5 @@
   PIAxes axes;
   axes.DrawXYAxes(g, mGrAtt, XMin(), XMax(), YMin(), YMax(),
-		  axesFlags, mAFSz, mFontSzF); 
+		  axesFlags, axesAFSz); 
   g->Clip();
 }
Index: /trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pidrawer.h	(revision 4077)
@@ -30,12 +30,5 @@
 
   virtual void       SetAxesFlags(unsigned int flags=kAxesNone);
-
-//---- Choix automatique ou pas de taille de fonte
-  inline void        ConfigureAutoFontSize(bool afsz=true, double fszf=0.04)
-    { mAFSz = afsz;  if (fszf>1e-5)  mFontSzF = fszf; }
-//  Valeur par defaut global pour le AutoFontSizeFrac, utilise dans les constructeurs de PIDrawer
-  static  void       SetGlDefAutoFontSizeFrac(double fszf=0.04);
-//  Retourne la valeur globale par defaut de AutoFontSizeFrac
-  static  double     GetGlDefAutoFontSizeFrac();
+  inline  void       SetAxesAutoFontSize(bool fg=true) { axesAFSz = fg; }
 
   virtual void       DrawAxes(PIGraphicUC* g);
@@ -60,11 +53,4 @@
   virtual void	     HighLight(bool fgh);  
 
-  // Zone de trace/accrochage dans le BaseWidget 
-  inline int         BWdgXPos() const { return xW0; }
-  inline int         BWdgYPos() const { return yW0; }
-  inline int         BWdgXSize() const { return xWd; }
-  inline int         BWdgYSize() const { return yWd; }
-
-  // Limites et informations sur les coordonnees dans le systeme du Drawer
   inline double      XMin() const {return xMin;}
   inline double      XMax() const {return xMax;}
@@ -77,7 +63,5 @@
 
   inline unsigned int GetAxesFlags() { return(axesFlags); }
-
-  inline bool         GetAutoFontSizeState() { return mAFSz; }
-  inline double       GetAutoFontSizeFraction() { return mFontSzF; }
+  inline bool         isAxesAutoFontSize() { return axesAFSz; }
 
   inline PIGraphicUC*    GetGraphicUC() { return(mGrUC); }
@@ -143,9 +127,5 @@
   bool limitsFixed;
   unsigned int axesFlags;
-
-  bool mAFSz;  // true -> Choix automatique de taille de font en fraction (ymax-ymin)
-  double mFontSzF;   // TailleFonteAuto = mFontSzF*(ymax-ymin)
-  static double glDefAFSzFrac;   // Valeur globale par defaut pour mFontSzF, utilise ds le constructeur
-
+  bool axesAFSz;
   PIBaseWdgGen* mBWdg;
   PIGraphicUC* mGrUC;
Index: /trunk/SophyaPI/PI/pieldrw.cc
===================================================================
--- /trunk/SophyaPI/PI/pieldrw.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pieldrw.cc	(revision 4077)
@@ -552,14 +552,4 @@
     else if (opts == "finecenteredaxesgrid")
       SetAxesFlags(kCentAxes | kTicks | kMajTicks | kMinTicks | kLabels | kGridOn);
-    else if (opts == "polaraxes") 
-      SetAxesFlags(kPolarAxes);
-    else if (opts.substr(0,10) == "polaraxes=") {
-      SetAxesFlags(kPolarAxes);
-      int nradius=5,nang=6;
-      int thetaoffdeg=0;
-      sscanf(opts.substr(10).c_str(),"%d,%d,%d",&nradius,&nang,&thetaoffdeg);
-      double thetaoffset=(double)thetaoffdeg*M_PI/180.;
-      axeDr.ConfigurePolar(nradius,nang,thetaoffset);
-    }
     else if (opts == "axesnone")
       SetAxesFlags(kAxesNone);
@@ -585,7 +575,7 @@
       SetAxesFlags(GetAxesFlags() & ~kMinTicks);
     else if (opts == "extticks")
-      SetAxesFlags((GetAxesFlags() & ~kIntTicks) |  kExtTicks);
+      SetAxesFlags(GetAxesFlags() & ~kIntTicks |  kExtTicks);
     else if (opts == "intticks")
-      SetAxesFlags((GetAxesFlags() & ~kExtTicks) |  kIntTicks);
+      SetAxesFlags(GetAxesFlags() & ~kExtTicks |  kIntTicks);
     else if (opts == "extintticks")
       SetAxesFlags(GetAxesFlags() | kIntTicks |  kExtTicks);
@@ -603,5 +593,13 @@
       }
     }
- 
+
+    else if (opts.substr(0,13) == "autofontsize=") {
+      double fszf = atof(opts.substr(13).c_str());
+      ConfigureAxeAutoFontSize(fszf);
+      SetAxesAutoFontSize(true);
+    }
+    else if (opts == "fixedfontsize")
+      SetAxesAutoFontSize(false);
+
     else if (opts == "title" || opts == "tit") ShowTitles(true);
     else if (opts == "notitle" || opts == "notit") ShowTitles(false);
@@ -641,6 +639,6 @@
   info += "   ticks/noticks minorticks/nominorticks \n";
   info += "   extticks/intticks/extintticks nbticks=X_NbTicks,Y_NbTicks \n";
-  info += "   tickslen=MajorTickLenFrac,MinorTickLenFraC \n"; 
-  info += " >> Axe labels font size: \n";
+  info += "   tickslen=MajorTickLenFrac,MinorTickLenFraC \n";
+  info += " >> Axe label font size: \n";
   info += "    autofontsize=FontSizeFrac fixedfontsize \n";
   info += " >> Up/Down title: title tit notitle notit \n";
@@ -657,5 +655,5 @@
   //  g->NoClip();
   axeDr.DrawXYAxes(g, mGrAtt, XMin(), XMax(), YMin(), YMax(), 
-		   axesFlags, mAFSz, mFontSzF); 
+		   axesFlags, axesAFSz); 
   if (showAxesLabels) { 
     axeDr.DrawXCaption(g, labelAtt, axesFlags, xLabel);
Index: /trunk/SophyaPI/PI/pieldrw.h
===================================================================
--- /trunk/SophyaPI/PI/pieldrw.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pieldrw.h	(revision 4077)
@@ -246,4 +246,6 @@
 				       double majtl=0., double mintl=0.)
      { axeDr.ConfigureTicks(ntickx, nticky, majtl, mintl); }
+  inline void        ConfigureAxeAutoFontSize(double fszf=0.)
+     { axeDr.ConfigureAutoFontSize(fszf); }
 
   inline PIElDrwMgr& ElDrwMgr()    { return eltsMgr; }
Index: /trunk/SophyaPI/PI/pifilechox.cc
===================================================================
--- /trunk/SophyaPI/PI/pifilechox.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pifilechox.cc	(revision 4077)
@@ -120,5 +120,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate(const_cast<char*>(path.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+xmstr = XmStringLtoRCreate((char *)path.c_str(), XmSTRING_DEFAULT_CHARSET);
 Arg warg[2];
 XtSetArg(warg[0], XmNdirectory, xmstr); 
@@ -132,5 +132,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate(const_cast<char*>(fname.c_str()),  const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+xmstr = XmStringLtoRCreate((char *)fname.c_str(), XmSTRING_DEFAULT_CHARSET);
 Arg warg[2];
 XtSetArg(warg[0], XmNtextString, xmstr); 
Index: /trunk/SophyaPI/PI/pifontx.cc
===================================================================
--- /trunk/SophyaPI/PI/pifontx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pifontx.cc	(revision 4077)
@@ -263,24 +263,19 @@
 
 static XtResource resources[] = {
-  { const_cast<char *>("fontFamilyName"), const_cast<char *>("FontFamilyName"), 
-    XtRString, sizeof(String),
+  { "fontFamilyName", "FontFamilyName", XtRString, sizeof(String),
     /*XtOffset(apd, fntFam[0])*/ 0, XtRString, const_cast<char *>("*-courier") } ,
-  { const_cast<char *>("courierfontFamilyName"), const_cast<char *>("CourierfontFamilyName"), 
-    XtRString, sizeof(String),
+  { "courierfontFamilyName", "CourierfontFamilyName", XtRString, sizeof(String),
     sizeof(String) , XtRString, const_cast<char *>("*-courier") } ,
-  { const_cast<char *>("helveticafontFamilyName"), const_cast<char *>("HelveticafontFamilyName"), 
-    XtRString, sizeof(String),
+  { "helveticafontFamilyName", "HelveticafontFamilyName", XtRString, sizeof(String),
     2*sizeof(String) , XtRString, const_cast<char *>("*-helvetica") } ,
-  { const_cast<char *>("timesfontFamilyName"), const_cast<char *>("TimesfontFamilyName"), 
-    XtRString, sizeof(String),
+  { "timesfontFamilyName", "TimesfontFamilyName", XtRString, sizeof(String),
     3*sizeof(String) , XtRString, const_cast<char *>("*-times") } ,
-  { const_cast<char *>("symbolfontFamilyName"), const_cast<char *>("SymbolfontFamilyName"), 
-    XtRString, sizeof(String),
+  { "symbolfontFamilyName", "SymbolfontFamilyName", XtRString, sizeof(String),
     4*sizeof(String) , XtRString, const_cast<char *>("*-symbol") }
 };
  
-static const char * fnbi_b[4] = { "medium-r-normal", "bold-r-normal", 
+static char * fnbi_b[4] = { "medium-r-normal", "bold-r-normal", 
                           "medium-o-normal", "bold-o-normal" };
-static const char * fnbo_b[4] = { NULL, NULL, 
+static char * fnbo_b[4] = { NULL, NULL, 
                           "medium-i-normal", "bold-i-normal" };
 
@@ -294,44 +289,31 @@
   int count,k;
   Display * mdsp = PIXDisplay();
-  char **list = NULL;
+  char **list;
 
   for (k=0; k<5; k++)  {  // Recherche de la fonte pour tailles croissantes
     sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbi_b[jat], fntsz[isz]+k);
     list = XListFonts(mdsp, buff, 10, &count);
+    XFreeFontNames(list);
     if ((count <= 0) && (fnbo_b[jat] != NULL)) {
-      if (list) XFreeFontNames(list);  
       sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbo_b[jat], fntsz[isz]+k);
       list = XListFonts(mdsp, buff, 10, &count);
+      XFreeFontNames(list);
     }
     if (count > 0)  break;
-  }
+    }
   // certaines fontes n'ont pas de version  bold ou italique
   if ( (count == 0) && (jat > 0) ) {
     for (k=0; k<5; k++)  {  // Recherche de la fonte pour tailles croissantes
-      if (list) XFreeFontNames(list);  
       sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbi_b[0], fntsz[isz]+k);
       list = XListFonts(mdsp, buff, 10, &count);
+      XFreeFontNames(list);
       if (count > 0)  break;
+      }
     }
-  }
-  if (count > 0) {
-    for (int kkk=0; kkk<count; kkk++) {
-      /*  pour debug 
-      printf("PIFontX::LoadFontSt/DBG - Call to XLoadFont(%s) \n", list[kkk]);
-      Font lfid=XLoadFont(mdsp,list[kkk]);
-      printf("PIFontX::LoadFontSt/DBG - Call to XQueryFont(FID=%ld) \n", (unsigned long)lfid); 
-      fntst[isz][jat][kfn] = XQueryFont(mdsp, lfid);   
-      printf("PIFontX::LoadFontSt/DBG - Call to XLoadQueryFont(%s) \n", list[kkk]); 
-      */
-      fntst[isz][jat][kfn] = XLoadQueryFont(mdsp, list[kkk]);
-      if (fntst[isz][jat][kfn] != NULL) break;
-    }
-    if (list) XFreeFontNames(list);  
-  }
-  else  { 
-    if (list) XFreeFontNames(list);  
-    printf("PIFontX::LoadFontSt/ Pb font %s - Using default \n", buff);    
-    fntst[isz][jat][kfn] = defnt; 
-    }
+  if (count > 0) 
+    fntst[isz][jat][kfn] = XLoadQueryFont(mdsp, buff);
+  else
+    { printf("PIFontX::LoadFontSt/ Pb font %s - Using default \n", buff);    
+    fntst[isz][jat][kfn] = defnt; }
   }
 
@@ -360,47 +342,37 @@
 XtGetApplicationResources(PIXtTopWdg(), &apd, resources, 
                           XtNumber(resources), NULL, 0);
-// printf("PIFontX::GlInit()-DBG- FontFamily = %s \n",apd.fntFam[0]);
-
 sprintf(buff,"-%s-*-*-*-*-*-*-*-*-*-*-*-*", apd.fntFam[0]);
-list = NULL;
 list = XListFonts(mdsp, buff, 15, &count);
+XFreeFontNames(list);
 if (count < 5)
   { 
   printf("PIFontX::Init %d fonts found for %s , switching to courier\n",
          count, apd.fntFam[0]);
-  apd.fntFam[0] = const_cast<char *>("*-courier");
-  if (list) XFreeFontNames(list);
+  apd.fntFam[0] = "*-courier";
   }
 sprintf(buff,"-%s-%s-*-*-*-*-12-*-*-*-*", apd.fntFam[0], fnbi_b[0]);
 list = XListFonts(mdsp, buff, 10, &count);
+XFreeFontNames(list);
 if (count < 1) {
-  if (list) XFreeFontNames(list);
   sprintf(buff,"-*-fixed-*-*-*-*-12-*-*-*-*-*-*-*");
   list = XListFonts(mdsp, buff, 10, &count);
+  XFreeFontNames(list);
   if (count < 1)   {  
-    if (list) XFreeFontNames(list);
     sprintf(buff,"fixed");
     list = XListFonts(mdsp, buff, 10, &count);
+    XFreeFontNames(list);
   }
   if (count < 1)   {  
-    if (list) XFreeFontNames(list);
     strcpy(buff,"");
     list = XListFonts(mdsp, buff, 10, &count);
+    XFreeFontNames(list);
   }
 }
 if (count < 1) {  
-  if (list) XFreeFontNames(list);
   printf("PIFontX::Init/ Erreur, no font found ... \n");
   defnt = NULL;
-  //Reza+Bruno, 17 Juin 2008 - Il faut lancer une exception 
-  }
-else { 
-  defnt = NULL;
-  for (int kkk=0; kkk<count; kkk++) {
-    defnt = XLoadQueryFont(mdsp, list[kkk]);
-    if (defnt != NULL) break;
-  }
-  if (list) XFreeFontNames(list);  
-}
+  }
+else defnt = XLoadQueryFont(mdsp, buff);
+
 for (i=0; i<NMAXFONTSZ; i++)
   for (j=0; j<NMAXFONTATT; j++)  
@@ -427,6 +399,6 @@
 // HugeFontIndex = NMAXFONTSZ-1;
 
-// printf("PIFontX::GlInit()-DBG- FontIndex= %d %d %d (SzF=%d) \n", 
-//       SmallFontIndex, NormalFontIndex, HugeFontIndex, szf);
+// printf("PIFontX::Init()-DBG- FontIndex= %d %d %d (SzF=%d) \n", 
+//       SmallFontIndex, NormalFontIndex, BigFontIndex, szf);
 
 return;
Index: /trunk/SophyaPI/PI/pigraphgen.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphgen.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphgen.h	(revision 4077)
@@ -17,5 +17,4 @@
 
 #include "pilineatt.h"  // Class PILineAtt
-#include "pipixutils.h"  // classes utilitaires pour pixels/RGB ...
 
 
@@ -119,6 +118,6 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, 
-                                PIColorMap* cmap)                              = 0;
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                                int sx, int sy, PIColorMap* cmap)              = 0;
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphps.cc	(revision 4077)
@@ -324,16 +324,11 @@
 
 /* --Methode-- */
-void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
-{
-int sx = pixc.XSize();
-int sy = pixc.YSize();
+void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                            int sx, int sy, PIColorMap* cmap)
+{
 if ( (sx < 1) || (sy < 1) )  return;
-if (cmap == NULL) return;
-if(mPSOut) {
-  if (pixc.BytePointer()) 
-    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.BytePointer(), cmap);
-  else if (pixc.ShortPointer()) 
-    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.ShortPointer(), cmap);
-}
+if ((pix == NULL) || (cmap == NULL)) return;
+if(mPSOut) 
+  mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pix, cmap);
 return;
 }
Index: /trunk/SophyaPI/PI/pigraphps.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphps.h	(revision 4077)
@@ -38,5 +38,6 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix,  PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                                int sx, int sy, PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphuc.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphuc.cc	(revision 4077)
@@ -168,7 +168,5 @@
 
   UC_CheckMinMaxDiff(xmin, xmax);
-  //cerr<<" DBG-SetUCS xmax-xmin= "<<xmax-xmin<<" xmin,max="<<xmin<<","<<xmax<<endl;
   UC_CheckMinMaxDiff(ymin, ymax);
-  //cerr<<" DBG-SetUCS ymax-ymin= "<<ymax-ymin<<" ymin,max="<<ymin<<","<<ymax<<endl;
 
   if (!UC_CheckFinite(xmin, xmax) || !UC_CheckFinite(ymin, ymax)) {
@@ -731,12 +729,13 @@
 
 /* --Methode-- */
-void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap)
-{
-  if (!mGrC) return;
-  if ( (pix.XSize() < 1) || (pix.YSize() < 1) )  return;
-  if (cmap == NULL) return; 
+void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix,
+                        int sx, int sy, PIColorMap* cmap)
+{
+  if (!mGrC) return;
+  if ( (sx < 1) || (sy < 1) )  return;
+  if ((pix == NULL) || (cmap == NULL)) return; 
   double xf,yf;
   UC2GrC(x, y, xf, yf);
-  mGrC->DrawPixmap(xf, yf, pix, cmap);
+  mGrC->DrawPixmap(xf, yf, pix, sx, sy, cmap);
 }
 
Index: /trunk/SophyaPI/PI/pigraphuc.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphuc.h	(revision 4077)
@@ -78,5 +78,6 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                                int sx, int sy, PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphx.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphx.cc	(revision 4077)
@@ -384,5 +384,6 @@
 
 /* --Methode-- */
-void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
+void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                            int sx, int sy, PIColorMap* cmap)
 {
 Window xw;
@@ -394,7 +395,6 @@
 XImage * ximg;
 
-int sx = pixc.XSize();
-int sy = pixc.YSize();
-if ((sx==0) || (sx==0) || (cmap == NULL)) return; 
+if ( (sx < 1) || (sy < 1) )  return;
+if ((pix == NULL) || (cmap == NULL)) return; 
 
   
@@ -406,5 +406,5 @@
 pad = (depth > 8) ? 32 : 8;
 ximg = XCreateImage (mdsp,DefaultVisual(mdsp,scr),
-                     depth,ZPixmap,0,NULL, sx,sy, pad,0);
+                     depth,ZPixmap,0,NULL, sx, sy, pad,0);
 if (ximg == NULL)  return;
 ximg->data = new char [sy*ximg->bytes_per_line];
@@ -412,20 +412,7 @@
   { XFree(ximg); return; }
 
-if (pixc.BytePointer()) {
-  unsigned char * pix = pixc.BytePointer();
-  for(j=0; j<sy; j++)
-    for(i=0; i<sx; i++)
-      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
-}
-else if (pixc.ShortPointer()) {
-  unsigned short * pix = pixc.ShortPointer();
-  for(j=0; j<sy; j++)
-    for(i=0; i<sx; i++)
-      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
-}
-else {
-  for(j=0; j<sy; j++)
-    for(i=0; i<sx; i++)  XPutPixel(ximg, i, j, 0 );  
-}
+for(j=0; j<sy; j++)
+  for(i=0; i<sx; i++)
+    { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
 
 XPutImage(mdsp, xw, DefGC(), ximg, 0, 0, (int)x, (int)y, sx, sy);
Index: /trunk/SophyaPI/PI/pigraphx.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pigraphx.h	(revision 4077)
@@ -38,5 +38,6 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y,  PIPixColIdx & pix,  PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
+                                int sx, int sy, PIColorMap* cmap);
 
 // Modifications attributs graphiques
